unit ProfileDataset;

interface
uses
  DBClient;

type
  {This is the delphi interceptor pattern}
  TClientDataset = class(DBClient.TClientDataset)
  public
    function DataRequest(Data: OleVariant): OleVariant; virtual;
  end;

implementation
uses
  windows, Tracelib;

{ TClientDataset }

{
  Note GetTickCount is only accurate to 10ms.
  Normally I would use QueryPeformanceCounter
  but that is NT only and harder work to use.
}
function TClientDataset.DataRequest(Data: OleVariant): OleVariant;
var
  aFirst, aSecond : Longint;
begin
  aFirst := GetTickCount;
  result := inherited DataRequest(Data);
  aSecond := GetTickCount;
  Trace( Format('%s took %dms',[self.Name, aSecond-aFirst]) );
end;

end.
